--******************************************************************************
--*  Structs v0.2b   part of Time Tracker for Max 4.2                          *
--*  (THIS IS A BETA VERSION, USE AT YOUE OWN RISK! DON'T USE FOR PRODUCTION)  *
--*                                                                            *
--*  by Ofer Zelichover (c) 02/2002                                            *
--*  www.tdp.nu/ofer   ;   ofer_z@hotmail.com                                  *
--*                                                                            *
--******************************************************************************
--*  You may use this script freely as you see fit.                            *
--*  You may use parts or the script as a whole in your own scripts.           *
--*  (it would be nice if you give me a credit if you do so ;))                *
--******************************************************************************
--*  This script comes with no waranty!                                        *
--*  Although I tried this script and couldn't find any problems with it, I can*
--*  in no way be held responsible for any kind of loss or damage, whether     *
--*  direct or indirect, due to the use of this script.                        *
--*                                                                            *
--*  ********************************************************************      *
--*  *** IF YOU DON'T LIKE THE ABOVE STATEMENT, DON'T USE THIS SCRIPT ***      *
--*  ********************************************************************      *
--*                                                                            *
--*  **** This script was written for max 4.2 and wasn't tested on other ****  *
--*  **** versions of max.                                               ****  *
--*                                                                            *
--*  If you find any bugs in this script, please let me know.                  *
--******************************************************************************
--* MODIFY AT YOUR OWN RISK!!!                                                 *
--******************************************************************************


-- Time struct to deal with adding/subtracting/displaying of time
struct time_struct (days=0, hours=0, minutes=0, seconds=0,
	hoursPerDay=24,
	-- functions --
	fn isKindOf s = s==time_struct OR s=="time_struct" OR s==#time_struct,
	fn intToTime i = (
		local t = time_struct hoursPerDay:hoursPerDay
		t.days = (i/(hoursPerDay*60*60)) as integer
		i = mod i (hoursPerDay*60*60)
		t.hours = (i/(60*60)) as integer
		i = mod i (60*60)
		t.minutes = (i/60) as integer
		t.seconds = (mod i 60) as integer
		t
	),
	fn timeToInt t = (
		local i = 0
		i += (t.days * (t.hoursPerDay*60*60)) as integer
		i += (t.hours * (60*60)) as integer
		i += (t.minutes * 60) as integer
		i += t.seconds as integer
		i
	),
	fn add t = (
		try (if t.isKindOf time_struct then t = t.timeToInt t)catch()
		local n = timeToInt (time_struct days:days hours:hours minutes:minutes seconds:seconds hoursPerDay:hoursPerDay)
		try (
			local tmpT = intToTime (n+t)
		)catch(ttPrintError "time_struct" "add()." ;return undefined)
		tmpT
	),
	fn subtract t = (
		try(if t.isKindOf time_struct then t = t.timeToInt t)catch()
		local n = timeToInt (time_struct days:days hours:hours minutes:minutes seconds:seconds hoursPerDay:hoursPerDay)
		try (
			local tmpT = intToTime (n-t)
		)catch(ttPrintError "time_struct" "subtart()."; return undefined)
		tmpT
	),
	fn equal t = (
		try(if t.isKindOf time_struct then t = t.timeToInt t)catch(ttPrintError "time_struct" "equal().")
		local n = timeToInt (time_struct days:days hours:hours minutes:minutes seconds:seconds hoursPerDay:hoursPerDay)
		t == n
	),
	fn strToTime s = (
		local tmpT = time_struct hoursPerDay:hoursPerDay
		try (
			local arr = filterString s ":"
			tmpT.days = arr[1] as integer
			tmpT.hours = arr[2] as integer
			tmpT.minutes = arr[3] as integer
			tmpT.seconds = arr[4] as integer
			tmpT = tmpT.add 0
		)catch(ttPrintError "time_struct" "strToTime().")
		tmpT
	),
	fn timeToStr = (
		local ss = "" as stringstream
		format "%:%:%:%" days hours minutes seconds to:ss
		ss as string
	)
)-- end time_struct


-------------------------------------------------------------------------------

struct ttSettings_struct (baseDir="", dataDir="",
	hoursPerWorkDay=8,
	tickInterval=(60*1000),
	askBeforeQuit=true,
	dialogPos,
	smallDialogPos,
	appDataAddr,
	debugMode=false
)-- ttSettings_struct

-------------------------------------------------------------------------------

-- the session struct holds the track time session info plus functions
-- to open and close the session (and save to files, as passed with the 
-- settings parameter)
struct ttSession_struct (
-- parameters --
	startTime, startDate,
	endTime, endDate,
	sessionTime,
	user, projectID, file,
	isClosed=false,
	trackingOn=false,
	settings=ttSettings_struct(),
-- functions --
	fn markStart = (
		startTime = (time_struct()).intToTime (timeStamp()/1000)
		startDate = (filterString localTime " ")[1]
		sessionTime = time_struct hoursPerDay:settings.hoursPerWorkDay
		OK
	),
	fn markEnd = (
		endTime = (time_struct()).intToTime (timeStamp()/1000)
		endDate = (filterString localTime " ")[1]
		OK
	),
	fn isStarted = startTime!=undefined AND startDate!=undefined,
	fn isEnded = endTime!=undefined AND endDate!=undefined,
	-- save the session info into the session file.
	fn save = (
		local returnVal = true
		local fName = settings.baseDir + settings.dataDir + "sessions.dat"
		local f
		if (getFiles fName).count == 0 then f = createFile fName
		else f = openFile fName mode:"a"
		if f != undefined then (
			try (
				local _sTime = try(startTime.timeToStr())catch("")
				local _sDate = if startDate!=undefined then startDate else ""
				local _eTime = try(endTime.timeToStr())catch("")
				local _eDate = if endDate!=undefined then endDate else ""
				local _sessTime = try(sessionTime.timeToStr())catch("")
				local _user = if user != undefined then user else ""
				local _projID = if projectID != undefined then projectID else ""
				local _file = if file != undefined then file else ""
				format "%; %; %; %; %; %; %; \"%\"\n"  _sTime _sDate \
							_eTime _eDate _sessTime _user _projID _file to:f
			)catch(returnVal = false; ttPrintError "ttSession_struct" "save().")
			flush f
			close f
		) else (
			returnVal = false
		)
		returnVal
	),
	-- saves the session to a temporary file, in case max crashes and the session isn't
	-- closed in a "clean" way.
	fn saveTemp = (
		if isStarted() then markEnd()
		local fName = settings.baseDir + settings.dataDir + "tmpSession.dat"
		try(setINISetting fName "Current Session" "startTime" (startTime.timeToStr()))catch()
		try(setINISetting fName "Current Session" "startDate" startDate)catch()
		try(setINISetting fName "Current Session" "endTime" (endTime.timeToStr()))catch()
		try(setINISetting fName "Current Session" "endDate" endDate)catch()
		try(setINISetting fName "Current Session" "sessionTime" (sessionTime.timeToStr()))catch()
		try(setINISetting fName "Current Session" "user" user)catch()
		try(setINISetting fName "Current Session" "projectID" (projectID as string))catch()
		try(setINISetting fName "Current Session" "file" file)catch()
		OK
	),
	fn init = (
		isClosed = false
		markStart()
		endTime=endDate = undefined
	),
	fn close = (
		if isClosed then return true
		if sessionTime==undefined OR sessionTime.equal 0 then (
			isClosed = true
			return true
		)
		local returnVal = true
		if NOT isStarted() then return false
		saveTemp()
		local fName = settings.baseDir + settings.dataDir + "tmpSession.dat"
		for i = 1 to 3 do (
			if save() then (
				returnVal = deleteFile fName
				isClosed = true
				exit
			) else (
				format "Could not close Time Tracker session.\n"
				returnVal = false
			)
		)
		returnVal
	)
)

-------------------------------------------------------------------------------

struct ttGenFuncs_struct (
	session=ttSession_struct(),
	-- try to update the UI in the dialogs
	fn updateUI = (
		try(ro_ttCurrentSession.updateSession())catch(ttPrintError "ttGenFuncs_struct:updateUI" "updateSession.")
		try(ro_ttCurrentSession.updateGUI())catch(ttPrintError "ttGenFuncs_struct:updateUI" "ro_ttCurrentSession.updateGUI.")
		try(ro_ttSmallDlg.updateGUI())catch(ttPrintError "ttGenFuncs_struct:updateUI" "ro_ttSmallDlg.updateGUI.")
	),
	
	-- update the properties of the current sessions that don't affect times.
	fn updateCurSess = (
		if session.user==undefined then session.user = sysInfo.userName
		session.file = maxFilePath + maxFileName
		session.projectID = try((getAppData globalTracks session.settings.appDataAddr) as integer)catch(ttPrintError "ttGenFuncs_struct" "updateCurSess()."; undefined)
		if session.projectID == undefined then session.trackingOn = false
	),
	
	-- this function is called when there has been a call to one of the file/new/reset
	-- callbacks. it checks if the file has changed, if so, it closes the previous session
	-- and opens a new one.
	fn callbacksFunc mode = (
		-- print the mode in debug mode.
		ttPrintError "ttGenFuncs_struct:callbacksFunc execute with mode" (mode as string)
	
		-- if session is not defined, there's nothing to do, so exit.
		if session == undefined then return()
		if NOT session.isStarted() then return()

		-- if the callback was due to new or reset, make sure the appData is cleared.
		if mode==#new OR mode==#reset then (
			try(
				(deleteAppData globalTracks session.settings.appDataAddr) as integer
			) catch(ttPrintError "ttGenFuncs_struct" "mode==#new.")
		) else (
			-- check if the file is the same as before. if so, exit.
			try (
				if session.file == (maxFilePath + maxFileName) AND mode!=#shutdown
					then return()
			)catch(ttPrintError "ttGenFuncs_struct" "mode==#new:else.")
		)

		-- if the previous file is undefined or empty, then the file was a new file
		-- and now saved with a different name. don't close the session, just update it and exit.
		if mode==#save then (
			try(
				if session.file == undefined OR session.file == "" then (
					updateCurSess()
					updateUI()
					return()
				)
			)catch(ttPrintError "ttGenFuncs_struct" "mode==#save.")
		)

		-- close the session and update the new one.
		try (session.close())catch(ttPrintError "ttGenFuncs_struct" "call to session.close().")
		try (session.init())catch(ttPrintError "ttGenFuncs_struct" "call to session.init().")
		try (updateCurSess())catch(ttPrintError "ttGenFuncs_struct" "call to updateCurSess().")
		try (updateUI())catch(ttPrintError "ttGenFuncs_struct" "call to updateUI().")
		
		gc()
	)
)

