--******************************************************************************
--*  Time Tracker v0.2b   part of Time Tracker for Max 4.2                     *
--*  (THIS IS A BETA VERSION, USE AT YOUE OWN RISK! DON'T USE FOR PRODUCTION)  *
--*                                                                            *
--*  by Ofer Zelichover (c) 02/2002                                            *
--*  www.tdp.nu/ofer   ;   ofer_z@hotmail.com                                  *
--*                                                                            *
--******************************************************************************
--*  You may use this script freely as you see fit.                            *
--*  You may use parts or the script as a whole in your own scripts.           *
--*  (it would be nice if you give me a credit if you do so ;))                *
--******************************************************************************
--*  This script comes with no waranty!                                        *
--*  Although I tried this script and couldn't find any problems with it, I can*
--*  in no way be held responsible for any kind of loss or damage, whether     *
--*  direct or indirect, due to the use of this script.                        *
--*                                                                            *
--*  ********************************************************************      *
--*  *** IF YOU DON'T LIKE THE ABOVE STATEMENT, DON'T USE THIS SCRIPT ***      *
--*  ********************************************************************      *
--*                                                                            *
--*  **** This script was written for max 4.2 and wasn't tested on other ****  *
--*  **** versions of max.                                               ****  *
--*                                                                            *
--*  If you find any bugs in this script, please let me know.                  *
--******************************************************************************
--* MODIFY AT YOUR OWN RISK!!!                                                 *
--******************************************************************************


-- db files:
-- projects.dat 	- holds projects details
-- clients.dat 		- holds clients details
-- users.dat		- holds users list
-- sessions.dat		- holds sessions details
-- tmpSession.dat	- holds tmp info about current session

macroScript timeTracker
	category:"Time Tracker"
	buttonText:"timeTracker"
	tooltip:"Time Tracker"
	icon:#("timeTracker", 1)
(
-- Declare Globals
--------------------
	global timeTrackerFloater
	global ro_ttCurrentSession
	
-- Declare Locals
-------------------
	local ro_ttConfigProjects 
	local ro_ttConfigClients 
	local ro_ttConfigUsers 
	local ro_ttGeneralSettings 
	local ro_ttAbout 

--============================================================================
-- Rollout definitions
--============================================================================

--*****************************************************************************
-- Current Session Rollout
--*****************************************************************************
	
	rollout ro_ttCurrentSession "Current Session" 
	(
	-- Local Variable Declerations
	--------------------------------
		-- the appData address where the projectID of the file will be saved.
		local ttAppDataAddr = ttSettings.appDataAddr
		
		-- the delay beween trackings in miliseconds.
		local ttTickInterval = try(ttSettings.tickInterval)catch(60*1000)

		local ttChooseUserList = #()
		local ttChooseProjList = #()
		local ttPrevProjID
		local ttPrevUser
		local ttCurProjTotalTime
		local ttSmallDlgBnPressed = false
		
	-- GUI
	--------
		checkButton ttTrack "Work In Progress (Time Tracking On ...)" width:310 height:25 highlightColor:(color 150 255 150) checked:false offset:[0,-5]
		checkButton ttPause "Out To Lunch (Pause Time Tracking ...)" width:310 height:25 highlightColor:(color 255 100 100) checked:true offset:[0,-3]
	
		group "Current User: " (
			label ttUserLbl "" width:240 align:#left across:2
			checkbutton ttUserChange "Change..." width:55 height:18 align:#right offset:[3,0]
			dropdownlist ttUserChangeList "" width:243 offset:[-500,-24]
		)
		group "Current File Is Assigned To Project: " (
			label ttProjectLbl "" width:240 align:#left across:2
			checkbutton ttProjectChange "Change..." width:55 height:18 align:#right offset:[3,0]
			dropdownlist ttProjectChangeList "" width:243 offset:[-500,-24]
		)
		
		group "Current Session Statistics: " (
			label ttFileName "File Name: " align:#left
			label ttFileSessTime "Time This Session: " align:#left
		)
	
		group "Current Project Statistics: " (
			label ttCurProjClient "Client: " align:#left
			label ttCurProjTotTime "Total Working Time: " align:#left
		)
	
		button ttSmallDlg "Switch To Small Dialog" width:150 height:20 across:2 offset:[-8,0]
		button ttClose "Close" width:150 height:20 offset:[8,0]
	
		timer ttTimer interval:ttTickInterval active:(ttCurSess.trackingOn)
	
	-- Functions
	---------------
	-- GUI functions
		-- shorten the filename string to fit in a specified width.
		fn truncFileDisplay str l = (
			if (getTextExtent str).x <= l then return str
			local fName = "\\" + filenameFromPath str
			local fPath = getFilenamePath str
			local returnStr = fPath + "..." + fName
			while (((getTextExtent returnStr).x > l) AND (fPath.count > 0)) do (
				fPath = subString fPath 1 (fPath.count-1)
				returnStr = fPath + "..." + fName
			)
			returnStr
		)
		
		-- change the states of the trackin on/off buttons
		fn changeTrackOnOff mode = (
			ttTrack.checked = mode
			ttPause.checked = NOT mode
			ttCurSess.trackingOn = ttTimer.active = mode
		)
	
		fn updateStatTimes = (
			ttFileSessTime.text = try ("Time This Session: " + ttCurSess.sessionTime.timeToStr())catch("Time This Session: ")
			ttCurProjTotTime.text =  try ("Total Working Time: " + (ttCurProjTotalTime.add ttCurSess.sessionTime).timeToStr())catch("Total Working Time: ")
		)
	
		fn updateStats = (
			updateStatTimes()
			ttFileName.text = try("File Name: " + (truncFileDisplay ttCurSess.file 250))catch("File Name: ")
			if ttCurSess.projectID != undefined then (
				local projNum = ro_ttConfigProjects.getProjectNumInList ttCurSess.projectID
				try (local clientID = ro_ttConfigProjects.ttProjectList[projNum].clientID)catch()
				local clientNum = ro_ttConfigClients.getCientNumInList clientID
				ttCurProjClient.text = try("Client: " + (ro_ttConfigClients.getClientList())[clientNum]) catch("Client: ")
			) else (
				ttCurProjClient.text = "Client: "
			)
		)
	
		fn updateGUI = (
			if ttCurSess.projectID != undefined then (
				local i = ro_ttConfigProjects.getProjectNumInList ttCurSess.projectID
				ttProjectChangeList.items = ro_ttConfigProjects.getProjectList()
				ttProjectChangeList.selection = i
				ttProjectLbl.text = ttProjectChangeList.selected
			) else (
				ttProjectChangeList.selection = 0
				ttProjectLbl.text = ""
			)
			ttUserLbl.text = if ttCurSess.user!=undefined then
				(ro_ttConfigUsers.getUserDetails ttCurSess.user) else ""
			ttTrack.enabled = ttCurSess.projectID!=undefined
			try(ttCurProjTotTime.text =  "Total Working Time: " + ttCurProjTotalTime.timeToStr())catch()
	
			updateStats()
			changeTrackOnOff ttCurSess.trackingOn
		)
		
		fn updateSession = (
			ttGenFuncs.updateCurSess()
			if ttCurSess.projectID != undefined then (
				local i = ro_ttConfigProjects.getProjectNumInList ttCurSess.projectID
				ttCurProjTotalTime = ro_ttConfigProjects.ttProjectList[i].totalTime
			) else (
				ttCurProjTotalTime = undefined
			)
		)
		
	-- session functions
		fn startSession = (
			ttCurSess.init()
			local i = ro_ttConfigProjects.getProjectNumInList ttCurSess.projectID
			ttCurProjTotalTime = ro_ttConfigProjects.ttProjectList[i].totalTime
			ttCurSess.file = maxFilePath + maxFileName
			updateStats()
			gc()
		)
	
		fn closeSession = (
			if NOT ttCurSess.isStarted() then return()
			while (NOT ttCurSess.close()) do (
				if NOT (queryBox "Could not close session. Retry?" title:"Time Tracker") then exit
			)
			if NOT (ttCurSess.sessionTime.equal 0) then
				try (ro_ttConfigProjects.ttProjectList[ttCurSess.projectID].totalTime = ttCurProjTotalTime.add ttCurSess.sessionTime) catch()
		)
	
		fn doTick = (
			-- update the session time and save to the tmpSession file.
			ttCurSess.sessionTime = ttCurSess.sessionTime.add (ttTickInterval/1000)
			ttCurSess.saveTemp()
			
			-- update the UI to show the session statistics.
			updateStatTimes()
			
			-- try to update the time in the small dialog
			try (ro_ttSmallDlg.updateTimeDisplay())catch()
		)
	
	-- general functions
	
		fn init = (
			-- initialize the rollouts in the right order
			ro_ttGeneralSettings.init()
			ro_ttConfigUsers.init()
			ro_ttConfigClients.init()
			ro_ttConfigProjects.init()
			
			-- initiate some variables
			ttSmallDlgBnPressed = false
			updateSession()
			
			-- update the GUI
			updateGUI()
	
			-- clean up
			gc()
		)
	
		fn done = (
			if NOT ttSmallDlgBnPressed then
				ttCurSess.trackingOn = false
			gc()
		)
		
	-- Event Handlers
	-------------------
		on ttTrack changed state do (
			changeTrackOnOff true
			if NOT ttCurSess.isStarted() then startSession()
			-- try to update the small dialog (if it exists).
			try(ro_ttSmallDlg.ttTrackOnOff.checked = true)catch()
		)
		on ttPause changed state do (
			-- try to update the small dialog (if it exists).
			try(ro_ttSmallDlg.ttTrackOnOff.checked = false)catch()
			changeTrackOnOff false
		)
	
		on ttUserChange changed state do (
			if state then (
				ttUserChangeList.pos.x = 13
				ttUserLbl.pos.x = -500
				ttUserChangeList.items = ro_ttConfigUsers.getUserList()
				ttPrevUser = ttCurSess.user
			) else (
				ttUserChangeList.pos.x = -500
				ttUserLbl.pos.x = 13
				local txt = ttUserChangeList.selected
				if txt != undefined then ttUserLbl.text = txt
				local i = ttUserChangeList.selection
				if i > 0 then (
					local newUser = ro_ttConfigUsers.ttUserList[i].username
					if newUser != ttPrevUser then (
						if ttCurSess.projectID != undefined then (
							if ttPrevUser!=undefined then closeSession()
							ttCurSess.user = newUser
							startSession()
						) else ttCurSess.user = newUser
					)
				)
			)
			ttProjectLbl.pos = ttProjectLbl.pos
		)
		
		on ttProjectChange changed state do (
			if state then (
				ttProjectChangeList.pos.x = 13
				ttProjectLbl.pos.x = -500
				ttProjectChangeList.items = ro_ttConfigProjects.getProjectList()
				ttPrevProjID = ttCurSess.projectID
			) else (
				ttProjectChangeList.pos.x = -500
				ttProjectLbl.pos.x = 13
				local txt = ttProjectChangeList.selected
				if txt != undefined then ttProjectLbl.text = txt
				local i = ttProjectChangeList.selection
				if i > 0 then (
					local newProjID = ro_ttConfigProjects.ttProjectList[i].ID
					if newProjID != ttPrevProjID then (
						if ttPrevProjID!=undefined then closeSession()
						setAppData globalTracks ttAppDataAddr (newProjID as string)
						ttCurSess.projectID = newProjID
						startSession()
					)
				)
				if ttCurSess.projectID!=undefined then ttTrack.enabled = true
			)
			ttUserLbl.pos = ttUserLbl.pos
		)
	
		on ttProjectChangeList selected item do (
			if item > 0 then ttCurSess.projectID = ro_ttConfigProjects.ttProjectList[item].ID
		)
	
	
		on ttTimer tick do (
			if ttCurSess.trackingOn then doTick()
		)
	
		on ttSmallDlg pressed do (
			ttSmallDlgBnPressed = true
			if ro_ttSmallDlg==undefined OR NOT ro_ttSmallDlg.open then
				macros.run "Time Tracker" "smallTracker"
			closeRolloutFloater timeTrackerFloater
		)
	
		on ttClose pressed do (
			closeRolloutFloater timeTrackerFloater
		)
		
		on ro_ttCurrentSession moved pos do (
			ttSettings.dialogPos = timeTrackerFloater.pos
		)
		
		on ro_ttCurrentSession OkToClose return (
			(ro_ttSmallDlg!=undefined AND ro_ttSmallDlg.open) OR \
			(NOT ttSettings.askBeforeQuit) OR \
			(queryBox "Quit Time Tracker?\n(tracking will stop)" title:"Time Tracker")
		)
		
		on ro_ttCurrentSession open do init()
		on ro_ttCurrentSession close do done()
	) -- end of ro_ttCurrentSession rollout
--*****************************************************************************
	
	
	
	
--*****************************************************************************
-- Config Projects Rollout
--*****************************************************************************
	
	rollout ro_ttConfigProjects "Projects Setup"
	(
	-- Local Struct Declerations
	-----------------------------
		struct proj_struct (ID=0, name="", dueTime="", clientID=0, comments="", 
			totalTime=(time_struct hoursPerDay:ttSettings.hoursPerWorkDay)
		)--end proj_struct
		
	-- Local Variable Declerations
	--------------------------------
		local ttProjectList = #()
	
	-- Local Function declerations
	----------------------------------
		local updateGUI
	
	-- GUI
	--------
		group "Projects: " (
			listbox ttProjList height:8 width:300
			edittext ttProjEditName "" fieldWidth:298 offset:[-3,0] enabled:false
			button ttProjAdd "New Project" width:80 height:18 across:2
			button ttProjDel "Delete Project" width:80 height:18 enabled:false
		)
		
		group "Project Details: " (
			dropdownlist ttProjClient "Client:" width:300 items:#()
			edittext ttProjDue "Due Date: " width:300
			label ttProjCommentsLbl "Comments: " align:#left
			edittext ttProjComments "" width:300 height:80
		)
		
		button ttProjSave "Save To File" width:80 height:18 across:2 tooltip:"Save projects list to file."
		button ttProjLoad "Load From File" width:80 height:18 tooltip:"Load projects list from file."
	
	
	-- Functions
	---------------
	-- general functions
		fn getProjectNumInList ID = (findItem (for i in ttProjectList collect i.ID) ID)
	
		fn getUniqueID lst = (
			local ids = #(0)
			try(ids = for i in lst collect i.ID)catch()
			if ids.count == 0 OR ids == undefined then 1
			else ((amax ids)+1)
		)
	
		fn getProjectList = (
			for i in ttProjectList collect i.name
		)
	
		fn filterValue s = (
			local n = findString s ">="
			if n == undefined then s
			else subString s (n+2) (s.count-(n+1))
		)
		
		fn replaceChars str rep repwith = (
			local n
			while ((n = findString str rep) != undefined) do (
				str = replace str n rep.count repwith
			)
			str
		)
	
	
	-- save/load functions	
		fn loadProjectList = (
			local returnVal = true
			local fName = ttSettings.baseDir + ttSettings.dataDir + "projects.dat"
			local f = openFile fName mode:"r"
			if f != undefined then (
				ttProjectList = #()
				local newProj
				try (
					while (NOT (eof f)) do (
						local l = readLine f
						if findString l "[Project_" != undefined then (
							if newProj != undefined then append ttProjectList newProj
							newProj = proj_struct()
						)
						if newProj != undefined then (
							if (findString l "<ID>=") == 1 then newProj.ID = (filterValue l) as integer
							if (findString l "<name>=") == 1 then newProj.name = filterValue l
							if (findString l "<dueTime>=") == 1 then newProj.dueTime = filterValue l
							if (findString l "<clientID>=") == 1 then newProj.clientID = (filterValue l) as integer
							if (findString l "<totalTime>=") == 1 then
								newProj.totalTime = (time_struct hoursPerDay:ttSettings.hoursPerWorkDay).strToTime (filterValue l)
							if (findString l "<comments>=") == 1 then newProj.comments = (replaceChars (replaceChars (filterValue l) "<&R>" "\r") "<&N>" "\n")
						)
					)
				)catch(print "Error loading project list.";returnVal = false)
				if newProj != undefined then append ttProjectList newProj
				close f
			) else (returnVal = false)
			updateGUI keepSel:false
			returnVal
		)-- end loadProjectList
	
		fn saveProjectList = (		
			local returnVal = true
			local fName = ttSettings.baseDir + ttSettings.dataDir + "projects.dat"
			local f = createFile fName
			if f != undefined then (
				try (
					local i = 1
					for p in ttProjectList do (
						format "[Project_%]\n" i to:f
						format "<ID>=%\n" p.ID to:f
						format "<name>=%\n" p.name to:f
						format "<dueTime>=%\n" p.dueTime to:f
						format "<clientID>=%\n" p.clientID to:f
						format "<totalTime>=%\n" (try (p.totalTime.timeToStr())catch("0:0:0:0")) to:f
						format "<comments>=%\n" (replaceChars (replaceChars p.comments "\r" "<&R>") "\n" "<&N>") to:f
						i += 1
					)
				)catch(returnVal = false)			
				close f
			) else (returnVal = false)
			returnVal
		)-- end saveProjectList
	
	-- GUI Functions
		fn updateClientID = (
			if ttProjList.selection == 0 then return()
			local IDs = for i in ro_ttConfigClients.ttClientList collect i.ID
			local n = findItem IDs ttProjectList[ttProjList.selection].clientID
			ttProjClient.items = ro_ttConfigClients.getClientList()
			ttProjClient.selection = n
		)
	
		fn enableGUI enbl = (
			ttProjEditName.enabled = enbl
			ttProjDel.enabled = enbl
			ttProjClient.enabled = enbl
			ttProjDue.enabled = enbl
			ttProjCommentsLbl.enabled = enbl
			ttProjComments.enabled = enbl
		)
		
		fn updateProjDetails sel = (
			enableGUI (sel>0)
			if sel > 0 then (
				ttProjEditName.text = ttProjectList[sel].name
				try(ttProjClient.selection = ttProjectList[sel].clientID) catch()
				ttProjDue.text = ttProjectList[sel].dueTime
				ttProjComments.text = ttProjectList[sel].comments
				updateClientID()
			) else (
				ttProjEditName.text = ""
				ttProjClient.selection = 0
				ttProjDue.text = ""
				ttProjComments.text = ""
				ttProjClient.items = #()
			)
		)
	
		fn updateGUI keepSel:true = (
			if NOT keepSel then ttProjList.selection = 0
			ttProjList.items = getProjectList()
			updateProjDetails ttProjList.selection
		)
	
		fn addProject = (
			local newID = getUniqueID ttProjectList
			local newName = "Project_"+newID as string
			local newDueTime = localTime
			local newProj = proj_struct newID newName newDueTime undefined ""
			append ttProjectList newProj
			ttProjList.items = getProjectList()
			ttProjList.selection = findItem ttProjList.items newName
			updateProjDetails ttProjList.selection
		)
	
		fn delProject sel = (
			if sel == 0 then return()
			local msg = "Delete project: " + ttProjectList[sel].name
			if (queryBox msg title:"Time Tracker") then (
				deleteItem ttProjectList sel
				ttProjList.items = getProjectList()
				ttProjList.selection = 0
				updateProjDetails ttProjList.selection
			)
		)
	
		fn init = (
			loadProjectList()
			updateGUI()
		)
		
		fn done = (
			saveProjectList()
		)
	
	-- Event Handlers
	-------------------
		on ttProjList selected item do (updateProjDetails item)
		on ttProjEditName changed text do (
			if ttProjList.selection > 0 then (
				ttProjectList[ttProjList.selection].name = text
				ttProjList.items = getProjectList()
			)
		)
		on ttProjAdd pressed do (addProject())
		on ttProjDel pressed do (delProject ttProjList.selection)
	
		on ttProjClient selected item do (
			if ttProjList.selection > 0 then 
				ttProjectList[ttProjList.selection].clientID = ro_ttConfigClients.ttClientList[item].ID
		)
		on ttProjDue entered text do (
			if ttProjList.selection > 0 then 
				ttProjectList[ttProjList.selection].dueTime = text
		)
		on ttProjComments entered text do (
			if ttProjList.selection > 0 then 
				ttProjectList[ttProjList.selection].comments = text
		)
		
		on ttProjSave pressed do (
			if (queryBox "Save updates in projects list to file?" title:"Time Tracker") then
				saveProjectList()
		)
		on ttProjLoad pressed do (
			if (queryBox "Load projects list from file?" title:"Time Tracker") then
				loadProjectList()
		)
		
		on ro_ttConfigProjects open do (init())
		on ro_ttConfigProjects close do (done())
	) -- end of ro_ttConfigProjects rollout
--*****************************************************************************
	
	
	
	
--*****************************************************************************
-- Config Clients Rollout
--*****************************************************************************
	
	rollout ro_ttConfigClients "Clients Setup"
	(
	-- Local Struct Declerations
	-----------------------------
		struct client_struct (ID, name, address, phone, cellphone, fax, email)
		
	-- Local Variable Declerations
	--------------------------------
		local ttClientList = #()
		
	-- Local Function Declerations
	--------------------------------
		local updateGUI
	
	-- GUI
	--------
		group "Clients: " (
			listbox ttClientDispList height:9 width:300
			edittext ttClientEditName "" fieldWidth:298 offset:[-3,0] enabled:false
			button ttClientAdd "New Client" width:80 height:18 across:2
			button ttClientDel "Delete Client" width:80 height:18 enabled:false
		)
		
		group "Client Details: " (
			label ttClientAddrLbl "Address:" align:#left
			edittext ttClientAddr "" height:50 width:300
			label ttClientPhoneLbl "Phone:" across:2 align:#left
			edittext ttClientPhone "" fieldWidth:240 align:#right offset:[4,0]
			label ttClientCellLbl "Cell Phone:" across:2 align:#left
			edittext ttClientCell "" fieldWidth:240 align:#right offset:[4,0]
			label ttClientFaxLbl "Fax:" across:2 align:#left
			edittext ttClientFax "" fieldWidth:240 align:#right offset:[4,0]
			edittext ttClientEmail "E-Mail: " width:300
		)
	
		button ttClientSave "Save To File" width:80 height:18 across:2 tooltip:"Save clients list to file."
		button ttClientLoad "Load From File" width:80 height:18 tooltip:"Load clients list from file."
	

	-- Functions
	---------------
		fn getCientNumInList ID = (findItem (for i in ttClientList collect i.ID) ID)

		fn filterValue s = (
			local n = findString s ">="
			if n == undefined then s
			else subString s (n+2) (s.count-(n+1))
		)
		
		fn replaceChars str rep repwith = (
			local n
			while ((n = findString str rep) != undefined) do (
				str = replace str n rep.count repwith
			)
			str
		)
		
		fn loadClientList = (
			local returnVal = true
			local fName = ttSettings.baseDir + ttSettings.dataDir + "clients.dat"
			local f = openFile fName mode:"r"
			if f != undefined then (
				ttClientList = #()
				local newClient
				try (
					while (NOT (eof f)) do (
						local l = readLine f
						if findString l "[Client_" != undefined then (
							if newClient != undefined then append ttClientList newClient
							newClient = client_struct()
						)
						if newClient != undefined then (
							if (findString l "<ID>=") == 1 then newClient.ID = (filterValue l) as integer
							if (findString l "<name>=") == 1 then newClient.name = filterValue l
							if (findString l "<address>=") == 1 then newClient.address = (replaceChars (replaceChars (filterValue l) "<&R>" "\r") "<&N>" "\n")
							if (findString l "<phone>=") == 1 then newClient.phone = filterValue l
							if (findString l "<cellPhone>=") == 1 then newClient.cellPhone = filterValue l
							if (findString l "<fax>=") == 1 then newClient.fax = filterValue l
							if (findString l "<email>=") == 1 then newClient.email = filterValue l
						)
					)
				)catch(print "Error loading client list.";returnVal = false)
				if newClient != undefined then append ttClientList newClient
				close f
			) else (returnVal = false)
			updateGUI keepSel:false
			returnVal
		)-- end loadClientList
	
		fn saveClientList = (
			local returnVal = true
			local fName = ttSettings.baseDir + ttSettings.dataDir + "clients.dat"
			local f = createFile fName
			if f != undefined then (
				try (
					local i = 1
					for c in ttClientList do (
						format "[Client_%]\n" i to:f
						format "<ID>=%\n" c.ID to:f
						format "<name>=%\n" c.name to:f
						format "<address>=%\n" (replaceChars (replaceChars c.address "\r" "<&R>") "\n" "<&N>") to:f
						format "<phone>=%\n" c.phone to:f
						format "<cellPhone>=%\n" c.cellPhone to:f
						format "<fax>=%\n" c.fax to:f
						format "<email>=%\n" c.email to:f
						i += 1
					)
				)catch(returnVal = false)			
				close f
			) else (returnVal = false)
			returnVal
		)-- end saveClientList
	
	
		fn getUniqueID lst = (
			local ids = #(0)
			try(ids = for i in lst collect i.ID)catch()
			if ids.count == 0 OR ids == undefined then 1
			else ((amax ids)+1)
		)
	
		fn getClientList = (
			for i in ttClientList collect i.name
		)
	
	-- GUI Functions
		fn enableGUI enbl = (
			ttClientEditName.enabled = enbl
			ttClientDel.enabled = enbl
			ttClientAddrLbl.enabled = enbl
			ttClientAddr.enabled = enbl
			ttClientPhoneLbl.enabled = enbl
			ttClientPhone.enabled = enbl
			ttClientCellLbl.enabled = enbl
			ttClientCell.enabled = enbl
			ttClientFaxLbl.enabled = enbl
			ttClientFax.enabled = enbl
			ttClientEmail.enabled = enbl
		)
		
		fn updateClientDetails sel = (
			enableGUI (sel>0)
			if sel > 0 then (
				ttClientEditName.text = ttClientList[sel].name
				ttClientAddr.text = ttClientList[sel].address
				ttClientPhone.text = ttClientList[sel].phone
				ttClientCell.text = ttClientList[sel].cellPhone
				ttClientFax.text = ttClientList[sel].fax
				ttClientEmail.text = ttClientList[sel].email
			) else (
				ttClientEditName.text = ""
				ttClientAddr.text = ""
				ttClientPhone.text = ""
				ttClientCell.text = ""
				ttClientFax.text = ""
				ttClientEmail.text = ""
			)
		)
		
		fn updateGUI keepSel:true = (
			if NOT keepSel then ttClientDispList.selection = 0
			ttClientDispList.items = getClientList()
			updateClientDetails ttClientDispList.selection
		)
		
		fn addClient = (
			local newID = getUniqueID ttClientList
			local newName = "Client_"+newID as string
			local newProj = client_struct newID newName "" "" "" "" ""
			append ttClientList newProj
			ttClientDispList.items = getClientList()
			ttClientDispList.selection = findItem ttClientDispList.items newName
			updateClientDetails ttClientDispList.selection
			ro_ttConfigProjects.updateClientID()
		)
	
		fn delClient sel = (
			if sel == 0 then return()
			local msg = "Delete Client: " + ttClientList[sel].name
			if (queryBox msg title:"Time Tracker") then (
				deleteItem ttClientList sel
				ttClientDispList.items = getClientList()
				ttClientDispList.selection = 0
				updateClientDetails ttClientDispList.selection
				ro_ttConfigProjects.updateClientID()
			)
		)
	
		fn init = (
			loadClientList()
			updateGUI()
		)
		
		fn done = (
			saveClientList()
		)
	
	-- Event Handlers
	-------------------
		on ttClientDispList selected item do (updateClientDetails item)
		on ttClientEditName changed text do (
			if ttClientDispList.selection > 0 then (
				ttClientList[ttClientDispList.selection].name = text
				ttClientDispList.items = getClientList()
			)
		)
		on ttClientAdd pressed do (addClient())
		on ttClientDel pressed do (delClient ttClientDispList.selection)
	
		on ttClientAddr entered text do (
			if ttClientDispList.selection > 0 then 
				ttClientList[ttClientDispList.selection].address = text
		)
		on ttClientPhone entered text do (
			if ttClientDispList.selection > 0 then 
				ttClientList[ttClientDispList.selection].phone = text
		)
		on ttClientCell entered text do (
			if ttClientDispList.selection > 0 then 
				ttClientList[ttClientDispList.selection].cellPhone = text
		)
		on ttClientFax entered text do (
			if ttClientDispList.selection > 0 then 
				ttClientList[ttClientDispList.selection].fax = text
		)
		on ttClientEmail entered text do (
			if ttClientDispList.selection > 0 then 
				ttClientList[ttClientDispList.selection].email = text
		)
	
		on ttClientSave pressed do (
			if (queryBox "Save updates in clients list to file?" title:"Time Tracker") then
				saveClientList()
		)
		on ttClientLoad pressed do (
			if (queryBox "Load clients list from file?" title:"Time Tracker") then
				loadClientList()
		)
	
		on ro_ttConfigClients open do (init())
		on ro_ttConfigClients close do (done())	
	) -- end of ro_ttConfigClients rollout
--*****************************************************************************
	
	
	
	
--*****************************************************************************
-- Config Users Rollout
--*****************************************************************************
	
	rollout ro_ttConfigUsers "Users Setup"
	(
	-- Local Struct Declerations
	------------------------------
		struct user_struct (username, realname)
	
	-- Local Variable Declerations
	--------------------------------
		local ttUserList = #()
	
	-- Local Functions Declerations
	----------------------------------
		local updateGUI
	
	-- GUI
	--------
		group "Users: " (
			listbox ttUserDisplayList height:10 width:300
			edittext ttUserEditUserName "Login Name: " width:300
			edittext ttUserEditRealName "Real Name: " width:300
			button ttUserAdd "New User" width:80 height:18 across:2
			button ttUserDel "Delete User" width:80 height:18 enabled:false
		)
	
		button ttUserSave "Save To File" width:80 height:18 offset:[0,10] across:2 tooltip:"Save users list to file."
		button ttUserLoad "Load From File" width:80 height:18 offset:[0,10] tooltip:"Load users list from file."
	
	
	-- Functions
	---------------
	-- general functions
		fn toLowerCase str = (
			local lowerCase = "abcdefghijklmnopqrstuvwxyz"
			local upperCase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
			local outStr = ""
			for i = 1 to str.count do (
				local n = findString upperCase str[i]
				if n != undefined then outStr += lowerCase[n]
				else outStr += str[i]
			)
			outStr
		)
	
		fn getUniqueName = (
			local names = for i in ttUserList collect i.username
			local i = 1
			local usrName = sysInfo.username
			if findItem names usrName == 0 then return usrName
			while (findItem names (usrName + i as string)!=0) do i+=1
			usrName+(i as string)
		)
	
		fn userExist usr = (
			local users = for i in ttUserList collect i.username
			findItem users usr > 0
		)
	
		fn getUserList = (
			for i in ttUserList collect (i.username + " - " + i.realname)
		)
		
		fn getUserDetails usr = (
			local details = ""
			for i in ttUserList where (toLowerCase i.username == toLowerCase usr) do
				details = " - " + i.realname
			usr+details
		)
		
	-- save/load functions
		fn saveUserList = (
			local fName = ttSettings.baseDir + ttSettings.dataDir + "users.dat"
			local f = createFile fName
			if f != undefined then (
				try (
					for i in ttUserList do
						format "%=%\n" i.username i.realname to:f
				) catch()
				flush f
				close f
			)
			true
		)-- end saveUserList
	
		fn loadUserList = (
			local fName = ttSettings.baseDir + ttSettings.dataDir + "users.dat"
			local f = openFile fName mode:"r"
			if f != undefined then (
				ttUserList = #()
				try (
					while NOT (eof f) do (
						local a = filterString (readLine f) "="
						if a.count==2 then (
							local newUser = user_struct username:a[1] realname:a[2]
							append ttUserList newUser
						)
					)
				)catch()
				close f
			)
			updateGUI keepSel:false
		)-- end loadUserList
	
	
	-- GUI functions
		fn enableGUI enbl = (
			ttUserEditUserName.enabled = enbl
			ttUserEditRealName.enabled = enbl
			ttUserDel.enabled = enbl
		)
		
		fn updateUserDetails sel = (
			enableGUI (sel>0)
			if sel > 0 then (
				ttUserEditUserName.text = ttUserList[sel].username
				ttUserEditRealName.text = ttUserList[sel].realname
			) else (
				ttUserEditUserName.text = ""
				ttUserEditRealName.text = ""
			)
		)
	
		fn updateGUI keepSel:true = (
			if NOT keepSel then ttUserDisplayList.selection = 0
			ttUserDisplayList.items = getUserList()
			updateUserDetails ttUserDisplayList.selection
		)
	
		fn addUser = (
			local newUser = user_struct username:(getUniqueName()) realname:""
			append ttUserList newUser
			ttUserDisplayList.items = getUserList()
			ttUserDisplayList.selection = ttUserDisplayList.items.count
			updateUserDetails ttUserDisplayList.selection
		)
	
		fn delUser sel = (
			if sel == 0 then return()
			local msg = "Delete User: " + ttUserList[sel].username
			if (queryBox msg title:"Time Tracker") then (
				deleteItem ttUserList sel
				updateGUI keepSel:false
			)
		)
	
		fn init = (
			loadUserList()
			if NOT userExist sysInfo.username then addUser()
		)
		
		fn done = (
			saveUserList()
		)
		
		
	-- Event Handlers
	-------------------
		on ttUserDisplayList selected item do (updateUserDetails item)
		on ttUserEditUserName changed text do (
			if ttUserDisplayList.selection > 0 then (
				ttUserList[ttUserDisplayList.selection].username = text
				ttUserDisplayList.items = getUserList()
			)
		)
		on ttUserEditRealName changed text do (
			if ttUserDisplayList.selection > 0 then (
				ttUserList[ttUserDisplayList.selection].realname = text
				ttUserDisplayList.items = getUserList()
			)
		)
		on ttUserAdd pressed do (addUser())
		on ttUserDel pressed do (delUser ttUserDisplayList.selection)
	
		on ttUserSave pressed do (
			if (queryBox "Save updates in users list to file?" title:"Time Tracker") then
				saveUserList()
		)
		on ttUserLoad pressed do (
			if (queryBox "Load users list from file?" title:"Time Tracker") then
				loadUserList()
		)
	
		on ro_ttConfigUsers open do init()
		on ro_ttConfigUsers close do done()
	
	) -- end of ro_ttConfigUsers rollout
--*****************************************************************************
	
	
	
	
--*****************************************************************************
-- General Settings Rollout
--*****************************************************************************
	
	rollout ro_ttGeneralSettings "General Settings"
	(
	-- GUI
	--------
		spinner ttSetHoursPerDay "Hours Per Work Day: " range:[1,24,8] fieldWidth:40 type:#integer align:#left
		spinner ttSettickInterval "Update Frequency (sec.): " range:[30,3600,60] fieldWidth:60 type:#integer align:#left
		checkbox ttSetaskBeforeQuit "Display Warning On Exit." checked:true

	
	-- Functions
	---------------
		fn loadSettings = (
			local fName = ttSettings.baseDir + "timeTracker.ini"
			local str = (getINISetting fName "Settings" "hoursPerWorkDay") as integer
			if str != undefined then ttSettings.hoursPerWorkDay = str
			str = (getINISetting fName "Settings" "tickInterval") as integer
			if str != undefined then ttSettings.tickInterval = str
			str = (getINISetting fName "Settings" "askBeforeQuit")=="true"
			if str != undefined then ttSettings.askBeforeQuit = str
			try (
				local arr = filterString (getINISetting fName "Settings" "dialogPos") "[,]"
				ttSettings.dialogPos = [(arr[1] as integer), (arr[2] as integer)]
			)catch()
			try (
				local arr = filterString (getINISetting fName "Settings" "smallDialogPos") "[,]"
				ttSettings.smallDialogPos = [(arr[1] as integer), (arr[2] as integer)]
			)catch()
		)
	
		fn saveSettings = (
			local fName = ttSettings.baseDir + "timeTracker.ini"
			if ttSettings.hoursPerWorkDay != undefined then
				setINISetting fName "Settings" "hoursPerWorkDay" (ttSettings.hoursPerWorkDay as string)
			if ttSettings.tickInterval != undefined then
				setINISetting fName "Settings" "tickInterval" (ttSettings.tickInterval as string)
			setINISetting fName "Settings" "askBeforeQuit" (ttSettings.askBeforeQuit as string)
			if ttSettings.dialogPos != undefined then
				setINISetting fName "Settings" "dialogPos" (ttSettings.dialogPos as string)
			if ttSettings.smallDialogPos != undefined then
				setINISetting fName "Settings" "smallDialogPos" (ttSettings.smallDialogPos as string)
		)

		fn checkSettings = (
			if ttSettings.hoursPerWorkDay < 1 OR ttSettings.hoursPerWorkDay > 24 then
				ttSettings.hoursPerWorkDay = 8
			if ttSettings.tickInterval < (30*1000) OR ttSettings.tickInterval > (3600*1000) then
				ttSettings.tickInterval = (60*1000)
			if classOf ttSettings.askBeforeQuit != BooleanClass then
				ttSettings.askBeforeQuit = true
		)

		fn updateGUI = (
			ttSetHoursPerDay.value = ttSettings.hoursPerWorkDay
			ttSettickInterval.value = ttSettings.tickInterval/1000
			ttSetaskBeforeQuit.checked = ttSettings.askBeforeQuit
		)

		fn init = (
			loadSettings()
			checkSettings()
			updateGUI()
			try(timeTrackerFloater.pos = ttSettings.dialogPos)catch()
			try (ro_ttCurrentSession.ttTickInterval = ttSettings.tickInterval)catch()
			try (ro_ttCurrentSession.ttTimer.interval = ttSettings.tickInterval)catch()
		)
	
		fn done = (
			saveSettings()
		)
	
	-- Event Handlers
	-------------------
		on ttSetHoursPerDay changed value do (
			ttSettings.hoursPerWorkDay = value
			saveSettings()
		)
		on ttSettickInterval changed value do (
			ttSettings.tickInterval = value * 1000
			try (ro_ttCurrentSession.ttTickInterval = value * 1000)catch()
			try (ro_ttCurrentSession.ttTimer.interval = value * 1000)catch()
			try (ro_ttSmallDlg.ttTimer.interval = value * 1000)catch()
			saveSettings()
		)
		on ttSetaskBeforeQuit changed state do (
			ttSettings.askBeforeQuit = state
			saveSettings()
		)
	
		on ro_ttGeneralSettings open do init()
		on ro_ttGeneralSettings close do done()
	) -- end of ro_ttGeneralSettings rollout
	
--*****************************************************************************
	
	
	
	
	
--*****************************************************************************
-- About Rollout
--*****************************************************************************
	
	rollout ro_ttAbout "About"
	(
	-- GUI
	--------
		label ttAboutLbl_01 "Time Tracker v0.2b"
		label ttAboutLbl_02 "By Ofer Zelichover"
		label ttAboutLbl_03 "(c) 02/2002"
	
	-- Functions
	---------------
	
	-- Event Handlers
	-------------------
	
	) -- end of ro_ttAbout rollout
	
--*****************************************************************************
	


-- macroScript Functions
------------------------------
	fn createDataDir = (
		try (
			local dirs = getDirectories (ttSettings.baseDir + "*.*")
			if findItem dirs ttSettings.dataDir == 0 then
				makeDir (ttSettings.baseDir + ttSettings.dataDir)
		)catch()
	)	
	
	
-- macroScript Event Handlers
------------------------------
	on execute do (
		createDataDir()
		local p = try(ttSettings.dialogPos) catch([10,100])
		if p == undefined then p = [10,100]
		try (closeRolloutFloater timeTrackerFloater)catch()
		timeTrackerFloater = newRolloutFloater "Time Tracker 0.2b" 350 470 p.x p.y
		addRollout ro_ttCurrentSession timeTrackerFloater
		addRollout ro_ttConfigProjects timeTrackerFloater rolledUp:true
		addRollout ro_ttConfigClients timeTrackerFloater rolledUp:true
		addRollout ro_ttConfigUsers timeTrackerFloater rolledUp:true
		addRollout ro_ttGeneralSettings timeTrackerFloater rolledUp:true
		addRollout ro_ttAbout timeTrackerFloater rolledUp:true
	)

) -- end macroScript